# coding: utf-8

"""
    Aladdin Corporate Action Entitlement

    API contains operations on Aladdin Corporate Action Entitlement resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.v1_corporate_action_validation import V1CorporateActionValidation
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.v1_elect_elections_response_details import V1ElectElectionsResponseDetails

class V1ElectElectionsResponse(BaseModel):
    """
    The response message for CorporateActionEntitlementAPI.ElectElections.
    """
    elect_elections_response_details: Optional[conlist(V1ElectElectionsResponseDetails)] = Field(None, alias="electElectionsResponseDetails", description="Response of elections elected.")
    general_validations: Optional[conlist(V1CorporateActionValidation)] = Field(None, alias="generalValidations", description="Any general warnings or errors occurring while performing this operation.")
    include_partial_errors: Optional[StrictBool] = Field(None, alias="includePartialErrors")
    __properties = ["electElectionsResponseDetails", "generalValidations", "includePartialErrors"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ElectElectionsResponse:
        """Create an instance of V1ElectElectionsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in elect_elections_response_details (list)
        _items = []
        if self.elect_elections_response_details:
            for _item in self.elect_elections_response_details:
                if _item:
                    _items.append(_item.to_dict())
            _dict['electElectionsResponseDetails'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in general_validations (list)
        _items = []
        if self.general_validations:
            for _item in self.general_validations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['generalValidations'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ElectElectionsResponse:
        """Create an instance of V1ElectElectionsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ElectElectionsResponse.parse_obj(obj)

        _obj = V1ElectElectionsResponse.parse_obj({
            "elect_elections_response_details": [V1ElectElectionsResponseDetails.from_dict(_item) for _item in obj.get("electElectionsResponseDetails")] if obj.get("electElectionsResponseDetails") is not None else None,
            "general_validations": [V1CorporateActionValidation.from_dict(_item) for _item in obj.get("generalValidations")] if obj.get("generalValidations") is not None else None,
            "include_partial_errors": obj.get("includePartialErrors")
        })
        return _obj

