# coding: utf-8

"""
    Aladdin Corporate Action Entitlement

    API contains operations on Aladdin Corporate Action Entitlement resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, conlist
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.rpc_status import RpcStatus
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.v1_corporate_action_validation import V1CorporateActionValidation
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.v1_election import V1Election
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.corporate_action.v1.CorporateActionEntitlementAPI.models.v1_entitlement_key import V1EntitlementKey

class V1ElectElectionsResponseDetails(BaseModel):
    """
    The response message for CorporateActionEntitlementAPI.ElectElections.
    """
    entitlement_key: Optional[V1EntitlementKey] = Field(None, alias="entitlementKey")
    elections: Optional[conlist(V1Election)] = Field(None, description="Corporate action election created/updated.")
    compliance_violated: Optional[StrictBool] = Field(None, alias="complianceViolated", description="Indicates whether compliance violations resulted from this operation.")
    corporate_action_validations: Optional[conlist(V1CorporateActionValidation)] = Field(None, alias="corporateActionValidations", description="Validation message (if applicable) for the elections associated with parent entitlement id.")
    status: Optional[RpcStatus] = None
    processed: Optional[StrictBool] = Field(None, description="Indicates whether the record is successfully created/updated or not.")
    __properties = ["entitlementKey", "elections", "complianceViolated", "corporateActionValidations", "status", "processed"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ElectElectionsResponseDetails:
        """Create an instance of V1ElectElectionsResponseDetails from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of entitlement_key
        if self.entitlement_key:
            _dict['entitlementKey'] = self.entitlement_key.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in elections (list)
        _items = []
        if self.elections:
            for _item in self.elections:
                if _item:
                    _items.append(_item.to_dict())
            _dict['elections'] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in corporate_action_validations (list)
        _items = []
        if self.corporate_action_validations:
            for _item in self.corporate_action_validations:
                if _item:
                    _items.append(_item.to_dict())
            _dict['corporateActionValidations'] = _items
        # override the default output from pydantic by calling `to_dict()` of status
        if self.status:
            _dict['status'] = self.status.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ElectElectionsResponseDetails:
        """Create an instance of V1ElectElectionsResponseDetails from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ElectElectionsResponseDetails.parse_obj(obj)

        _obj = V1ElectElectionsResponseDetails.parse_obj({
            "entitlement_key": V1EntitlementKey.from_dict(obj.get("entitlementKey")) if obj.get("entitlementKey") is not None else None,
            "elections": [V1Election.from_dict(_item) for _item in obj.get("elections")] if obj.get("elections") is not None else None,
            "compliance_violated": obj.get("complianceViolated"),
            "corporate_action_validations": [V1CorporateActionValidation.from_dict(_item) for _item in obj.get("corporateActionValidations")] if obj.get("corporateActionValidations") is not None else None,
            "status": RpcStatus.from_dict(obj.get("status")) if obj.get("status") is not None else None,
            "processed": obj.get("processed")
        })
        return _obj

