# coding: utf-8

"""
    Coupon Reset

    Coupon in Aladdin are generated internally by Aladdin's Bulk Rate Mechanism (BRM) module or sourced from external vendors. This API allows for retrieval of coupon reset records based on a number of criteria including assetId, dates and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional
from pydantic import BaseModel, Field

class TypesRangeValue(BaseModel):
    """
    TypesRangeValue
    """
    begin_date: date = Field(..., alias="beginDate")
    end_date: Optional[date] = Field(None, alias="endDate")
    __properties = ["beginDate", "endDate"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> TypesRangeValue:
        """Create an instance of TypesRangeValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> TypesRangeValue:
        """Create an instance of TypesRangeValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return TypesRangeValue.parse_obj(obj)

        _obj = TypesRangeValue.parse_obj({
            "begin_date": obj.get("beginDate"),
            "end_date": obj.get("endDate")
        })
        return _obj

