# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json



from pydantic import BaseModel, Field, StrictStr, constr

class PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response(BaseModel):
    """
    Defines an error that occurred.
    """
    code: constr(strict=True, max_length=40) = Field(..., description="A short mnemonic reference code for the error.")
    message: StrictStr = Field(..., description="A human readable description of the error.")
    __properties = ["code", "message"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response:
        """Create an instance of PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response:
        """Create an instance of PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response.parse_obj(obj)

        _obj = PrincipalInterestFactorAPIGetPrincipalInterestFactor400Response.parse_obj({
            "code": obj.get("code"),
            "message": obj.get("message")
        })
        return _obj

