# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date
from typing import Optional, Union
from pydantic import BaseModel, Field, StrictBool, StrictFloat, StrictInt, StrictStr
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.principal_interest_factor_state import PrincipalInterestFactorState

class PrincipalInterestFactorPrincipalInterestFactorDetail(BaseModel):
    """
    PrincipalInterestFactorPrincipalInterestFactorDetail
    """
    id: Optional[StrictInt] = None
    pif_sequence_number: Optional[StrictInt] = Field(None, alias="pifSequenceNumber")
    asset_id: Optional[StrictStr] = Field(None, alias="assetId")
    accrual_type: Optional[StrictStr] = Field(None, alias="accrualType")
    principal: Optional[Union[StrictFloat, StrictInt]] = None
    principal_state: Optional[PrincipalInterestFactorState] = Field(None, alias="principalState")
    principal_accrual_date: Optional[date] = Field(None, alias="principalAccrualDate")
    interest: Optional[Union[StrictFloat, StrictInt]] = None
    interest_state: Optional[PrincipalInterestFactorState] = Field(None, alias="interestState")
    interest_accrual_date: Optional[date] = Field(None, alias="interestAccrualDate")
    interest_accrual_end_date: Optional[date] = Field(None, alias="interestAccrualEndDate")
    entry_date: Optional[date] = Field(None, alias="entryDate")
    calculation_days_convention: Optional[StrictStr] = Field(None, alias="calculationDaysConvention")
    coupon: Optional[Union[StrictFloat, StrictInt]] = None
    coupon_source: Optional[StrictStr] = Field(None, alias="couponSource")
    current_factor: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="currentFactor")
    previous_factor: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="previousFactor")
    period_day_count: Optional[StrictInt] = Field(None, alias="periodDayCount")
    next_payment_date: Optional[date] = Field(None, alias="nextPaymentDate")
    nominal_payment_date: Optional[date] = Field(None, alias="nominalPaymentDate")
    final_payment: Optional[StrictBool] = Field(None, alias="finalPayment", description="Represents whether this is the final payment. Final payments are ignored by gen_pni and the amount is posted as a trade by rm_mat.")
    user_principal: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="userPrincipal")
    user_interest: Optional[Union[StrictFloat, StrictInt]] = Field(None, alias="userInterest")
    pif_detail_comment: Optional[StrictStr] = Field(None, alias="pifDetailComment")
    currency_code: Optional[StrictStr] = Field(None, alias="currencyCode")
    __properties = ["id", "pifSequenceNumber", "assetId", "accrualType", "principal", "principalState", "principalAccrualDate", "interest", "interestState", "interestAccrualDate", "interestAccrualEndDate", "entryDate", "calculationDaysConvention", "coupon", "couponSource", "currentFactor", "previousFactor", "periodDayCount", "nextPaymentDate", "nominalPaymentDate", "finalPayment", "userPrincipal", "userInterest", "pifDetailComment", "currencyCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> PrincipalInterestFactorPrincipalInterestFactorDetail:
        """Create an instance of PrincipalInterestFactorPrincipalInterestFactorDetail from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> PrincipalInterestFactorPrincipalInterestFactorDetail:
        """Create an instance of PrincipalInterestFactorPrincipalInterestFactorDetail from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return PrincipalInterestFactorPrincipalInterestFactorDetail.parse_obj(obj)

        _obj = PrincipalInterestFactorPrincipalInterestFactorDetail.parse_obj({
            "id": obj.get("id"),
            "pif_sequence_number": obj.get("pifSequenceNumber"),
            "asset_id": obj.get("assetId"),
            "accrual_type": obj.get("accrualType"),
            "principal": obj.get("principal"),
            "principal_state": obj.get("principalState"),
            "principal_accrual_date": obj.get("principalAccrualDate"),
            "interest": obj.get("interest"),
            "interest_state": obj.get("interestState"),
            "interest_accrual_date": obj.get("interestAccrualDate"),
            "interest_accrual_end_date": obj.get("interestAccrualEndDate"),
            "entry_date": obj.get("entryDate"),
            "calculation_days_convention": obj.get("calculationDaysConvention"),
            "coupon": obj.get("coupon"),
            "coupon_source": obj.get("couponSource"),
            "current_factor": obj.get("currentFactor"),
            "previous_factor": obj.get("previousFactor"),
            "period_day_count": obj.get("periodDayCount"),
            "next_payment_date": obj.get("nextPaymentDate"),
            "nominal_payment_date": obj.get("nominalPaymentDate"),
            "final_payment": obj.get("finalPayment"),
            "user_principal": obj.get("userPrincipal"),
            "user_interest": obj.get("userInterest"),
            "pif_detail_comment": obj.get("pifDetailComment"),
            "currency_code": obj.get("currencyCode")
        })
        return _obj

