# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, conlist
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.v1_create_principal_interest_factor_result import V1CreatePrincipalInterestFactorResult

class V1BatchCreatePrincipalInterestFactorsResponse(BaseModel):
    """
    V1BatchCreatePrincipalInterestFactorsResponse
    """
    results: Optional[conlist(V1CreatePrincipalInterestFactorResult)] = None
    __properties = ["results"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BatchCreatePrincipalInterestFactorsResponse:
        """Create an instance of V1BatchCreatePrincipalInterestFactorsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in results (list)
        _items = []
        if self.results:
            for _item in self.results:
                if _item:
                    _items.append(_item.to_dict())
            _dict['results'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BatchCreatePrincipalInterestFactorsResponse:
        """Create an instance of V1BatchCreatePrincipalInterestFactorsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BatchCreatePrincipalInterestFactorsResponse.parse_obj(obj)

        _obj = V1BatchCreatePrincipalInterestFactorsResponse.parse_obj({
            "results": [V1CreatePrincipalInterestFactorResult.from_dict(_item) for _item in obj.get("results")] if obj.get("results") is not None else None
        })
        return _obj

