# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import date

from pydantic import BaseModel, Field, StrictStr

class V1Key(BaseModel):
    """
    V1Key
    """
    asset_id: StrictStr = Field(..., alias="assetId")
    record_date: date = Field(..., alias="recordDate")
    payment_date: date = Field(..., alias="paymentDate")
    currency_code: StrictStr = Field(..., alias="currencyCode")
    __properties = ["assetId", "recordDate", "paymentDate", "currencyCode"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1Key:
        """Create an instance of V1Key from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1Key:
        """Create an instance of V1Key from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1Key.parse_obj(obj)

        _obj = V1Key.parse_obj({
            "asset_id": obj.get("assetId"),
            "record_date": obj.get("recordDate"),
            "payment_date": obj.get("paymentDate"),
            "currency_code": obj.get("currencyCode")
        })
        return _obj

