# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import json
import pprint
import re  # noqa: F401
from aenum import Enum, no_arg





class V1ParameterName(str, Enum):
    """
    - PARAMETER_NAME_UNSPECIFIED: Unspecified parameter name  - PARAMETER_NAME_ASSET_IDS: Represents one or more asset identifiers on which filtering should be applied  - PARAMETER_NAME_RECORD_DATE: Represents starting range of record date of the PIF  - PARAMETER_NAME_PAYMENT_DATE: Represents starting range of payment date of the PIF  - PARAMETER_NAME_MODIFY_DATE: Represents starting range of modify date of the PIF (i.e. entry date)  - PARAMETER_NAME_CURRENCY_CODES: Represents one or more currencies on which filtering should be applied  - PARAMETER_NAME_SECURITY_GROUP_AND_TYPE: Represents security group and type  - PARAMETER_NAME_REC_SOURCE: Source against which this PIF has been reconciled  - PARAMETER_NAME_PRINCIPAL_ACCRUAL_DATE: Represents starting range of principal accrual date of the PIF  - PARAMETER_NAME_INTEREST_ACCRUAL_DATE: Represents starting range of interest accrual date of the PIF  - PARAMETER_NAME_COUPON_TYPE: Represents coupon type of the PIF  - PARAMETER_NAME_PAYMENT_SETTLE_LOCATION: Represents payment settle location of the PIF  - PARAMETER_NAME_PRINCIPAL_STATUS: Represents principal status of the PIF  - PARAMETER_NAME_INTEREST_STATUS: Represents interest status of the PIF  - PARAMETER_NAME_CONFIRMED_STATUS: Represents confirmed status of the PIF  - PARAMETER_NAME_CONFIRMED_BY: Represents confirmed by of the PIF  - PARAMETER_NAME_PAYMENT_SOURCE: Represents payment source by of the PIF
    """

    """
    allowed enum values
    """
    PARAMETER_NAME_UNSPECIFIED = 'PARAMETER_NAME_UNSPECIFIED'
    PARAMETER_NAME_ASSET_IDS = 'PARAMETER_NAME_ASSET_IDS'
    PARAMETER_NAME_RECORD_DATE = 'PARAMETER_NAME_RECORD_DATE'
    PARAMETER_NAME_PAYMENT_DATE = 'PARAMETER_NAME_PAYMENT_DATE'
    PARAMETER_NAME_MODIFY_DATE = 'PARAMETER_NAME_MODIFY_DATE'
    PARAMETER_NAME_CURRENCY_CODES = 'PARAMETER_NAME_CURRENCY_CODES'
    PARAMETER_NAME_SECURITY_GROUP_AND_TYPE = 'PARAMETER_NAME_SECURITY_GROUP_AND_TYPE'
    PARAMETER_NAME_REC_SOURCE = 'PARAMETER_NAME_REC_SOURCE'
    PARAMETER_NAME_PRINCIPAL_ACCRUAL_DATE = 'PARAMETER_NAME_PRINCIPAL_ACCRUAL_DATE'
    PARAMETER_NAME_INTEREST_ACCRUAL_DATE = 'PARAMETER_NAME_INTEREST_ACCRUAL_DATE'
    PARAMETER_NAME_COUPON_TYPE = 'PARAMETER_NAME_COUPON_TYPE'
    PARAMETER_NAME_PAYMENT_SETTLE_LOCATION = 'PARAMETER_NAME_PAYMENT_SETTLE_LOCATION'
    PARAMETER_NAME_PRINCIPAL_STATUS = 'PARAMETER_NAME_PRINCIPAL_STATUS'
    PARAMETER_NAME_INTEREST_STATUS = 'PARAMETER_NAME_INTEREST_STATUS'
    PARAMETER_NAME_CONFIRMED_STATUS = 'PARAMETER_NAME_CONFIRMED_STATUS'
    PARAMETER_NAME_CONFIRMED_BY = 'PARAMETER_NAME_CONFIRMED_BY'
    PARAMETER_NAME_PAYMENT_SOURCE = 'PARAMETER_NAME_PAYMENT_SOURCE'

    @classmethod
    def from_json(cls, json_str: str) -> V1ParameterName:
        """Create an instance of V1ParameterName from a JSON string"""
        return V1ParameterName(json.loads(json_str))


