# coding: utf-8

"""
    Principal and Interest Factor

    Principal and Interest Factors (PIFs) generally represent the amount of payment per 1000 of Original Face currency units value you currently hold in the given asset, and are used in conjunction with position data to generate cashflows. This API allows for filtering and retrieval of PIF records based on a number of criteria including assetId, dates, security groups, currency and more.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.types_range_value import TypesRangeValue
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.types_repeated_value import TypesRepeatedValue
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.types_single_value import TypesSingleValue
from asdk_plugin_investment_operations.agraph.investment_operations.asset_lifecycle.principal_interest_factor.v1.PrincipalInterestFactorAPI.models.v1_asset_filter import V1AssetFilter

class V1ParameterValue(BaseModel):
    """
    V1ParameterValue
    """
    single_value: Optional[TypesSingleValue] = Field(None, alias="singleValue")
    repeated_value: Optional[TypesRepeatedValue] = Field(None, alias="repeatedValue")
    range_value: Optional[TypesRangeValue] = Field(None, alias="rangeValue")
    asset_filter: Optional[V1AssetFilter] = Field(None, alias="assetFilter")
    __properties = ["singleValue", "repeatedValue", "rangeValue", "assetFilter"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1ParameterValue:
        """Create an instance of V1ParameterValue from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of single_value
        if self.single_value:
            _dict['singleValue'] = self.single_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of repeated_value
        if self.repeated_value:
            _dict['repeatedValue'] = self.repeated_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of range_value
        if self.range_value:
            _dict['rangeValue'] = self.range_value.to_dict()
        # override the default output from pydantic by calling `to_dict()` of asset_filter
        if self.asset_filter:
            _dict['assetFilter'] = self.asset_filter.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1ParameterValue:
        """Create an instance of V1ParameterValue from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1ParameterValue.parse_obj(obj)

        _obj = V1ParameterValue.parse_obj({
            "single_value": TypesSingleValue.from_dict(obj.get("singleValue")) if obj.get("singleValue") is not None else None,
            "repeated_value": TypesRepeatedValue.from_dict(obj.get("repeatedValue")) if obj.get("repeatedValue") is not None else None,
            "range_value": TypesRangeValue.from_dict(obj.get("rangeValue")) if obj.get("rangeValue") is not None else None,
            "asset_filter": V1AssetFilter.from_dict(obj.get("assetFilter")) if obj.get("assetFilter") is not None else None
        })
        return _obj

