# coding: utf-8

"""
    Account Info

    API contains operations on Account Info resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


import re  # noqa: F401
import io
import warnings

from pydantic import validate_arguments, ValidationError
from typing_extensions import Annotated

from datetime import datetime

from pydantic import Field, StrictInt, StrictStr

from typing import Optional

from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.models.v1_filter_account_infos_request import V1FilterAccountInfosRequest
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.models.v1_filter_account_infos_response import V1FilterAccountInfosResponse
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.models.v1_search_account_infos_response import V1SearchAccountInfosResponse

from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.api_client import ApiClient
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.api_response import ApiResponse
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.account_info.v1.AccountInfoAPI.exceptions import (  # noqa: F401
    ApiTypeError,
    ApiValueError
)


class DefaultAccountInfoAPI(object):
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None):
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_arguments
    def account_info_api_filter_account_infos(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : V1FilterAccountInfosRequest, **kwargs) -> V1FilterAccountInfosResponse:  # noqa: E501
        """Filter Account Info  # noqa: E501

        Filters account info basis list of account codes or other custom filter criterias.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.account_info_api_filter_account_infos(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: (required)
        :type body: V1FilterAccountInfosRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1FilterAccountInfosResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the account_info_api_filter_account_infos_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.account_info_api_filter_account_infos_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, **kwargs)  # noqa: E501

    @validate_arguments
    def account_info_api_filter_account_infos_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], body : V1FilterAccountInfosRequest, **kwargs) -> ApiResponse:  # noqa: E501
        """Filter Account Info  # noqa: E501

        Filters account info basis list of account codes or other custom filter criterias.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.account_info_api_filter_account_infos_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, body, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param body: (required)
        :type body: V1FilterAccountInfosRequest
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1FilterAccountInfosResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'body'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method account_info_api_filter_account_infos" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        if _params['body'] is not None:
            _body_params = _params['body']

        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # set the HTTP header `Content-Type`
        _content_types_list = _params.get('_content_type',
            self.api_client.select_header_content_type(
                ['application/json']))
        if _content_types_list:
                _header_params['Content-Type'] = _content_types_list

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1FilterAccountInfosResponse",
            '400': "AccountInfoAPIFilterAccountInfos400Response",
            '401': "AccountInfoAPIFilterAccountInfos400Response",
            '403': "AccountInfoAPIFilterAccountInfos400Response",
            '404': "AccountInfoAPIFilterAccountInfos400Response",
        }

        return self.api_client.call_api(
            '/accountInfos:filter', 'POST',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))

    @validate_arguments
    def account_info_api_search_account_infos(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], search : Annotated[StrictStr, Field(..., description="Search string. Represents Search string (atleast two characters).")], acct_info_search_type : Annotated[Optional[StrictStr], Field(description="Account Info Search Type. Represents search type.   - ACCOUNT_INFO_SEARCH_TYPE_UNSPECIFIED: The API will default to the ACCOUNT_NAME type  - ACCOUNT_INFO_SEARCH_TYPE_ACCOUNT_NAME: This is the default value Fields searched - accountName.")] = None, page_size : Annotated[Optional[StrictInt], Field(description="The maximum value is 100; values above 100 will be coerced to 100 If unspecified, the default value to return is 100 The maximum number of Brokers to return (Pagination is not supported currently).")] = None, page_token : Annotated[Optional[StrictStr], Field(description="A page token, received from a previous call (Pagination is not supported currently).")] = None, **kwargs) -> V1SearchAccountInfosResponse:  # noqa: E501
        """Search Account Info  # noqa: E501

        Searches Account Info based on the input query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.account_info_api_search_account_infos(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, search, acct_info_search_type, page_size, page_token, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param search: Search string. Represents Search string (atleast two characters). (required)
        :type search: str
        :param acct_info_search_type: Account Info Search Type. Represents search type.   - ACCOUNT_INFO_SEARCH_TYPE_UNSPECIFIED: The API will default to the ACCOUNT_NAME type  - ACCOUNT_INFO_SEARCH_TYPE_ACCOUNT_NAME: This is the default value Fields searched - accountName.
        :type acct_info_search_type: str
        :param page_size: The maximum value is 100; values above 100 will be coerced to 100 If unspecified, the default value to return is 100 The maximum number of Brokers to return (Pagination is not supported currently).
        :type page_size: int
        :param page_token: A page token, received from a previous call (Pagination is not supported currently).
        :type page_token: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: V1SearchAccountInfosResponse
        """
        kwargs['_return_http_data_only'] = True
        if '_preload_content' in kwargs:
            raise ValueError("Error! Please call the account_info_api_search_account_infos_with_http_info method with `_preload_content` instead and obtain raw data from ApiResponse.raw_data")
        return self.account_info_api_search_account_infos_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, search, acct_info_search_type, page_size, page_token, **kwargs)  # noqa: E501

    @validate_arguments
    def account_info_api_search_account_infos_with_http_info(self, vnd_com_blackrock_request_id : Annotated[StrictStr, Field(..., description="A unique identifier for this request.")], vnd_com_blackrock_origin_timestamp : Annotated[datetime, Field(..., description="Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231.")], search : Annotated[StrictStr, Field(..., description="Search string. Represents Search string (atleast two characters).")], acct_info_search_type : Annotated[Optional[StrictStr], Field(description="Account Info Search Type. Represents search type.   - ACCOUNT_INFO_SEARCH_TYPE_UNSPECIFIED: The API will default to the ACCOUNT_NAME type  - ACCOUNT_INFO_SEARCH_TYPE_ACCOUNT_NAME: This is the default value Fields searched - accountName.")] = None, page_size : Annotated[Optional[StrictInt], Field(description="The maximum value is 100; values above 100 will be coerced to 100 If unspecified, the default value to return is 100 The maximum number of Brokers to return (Pagination is not supported currently).")] = None, page_token : Annotated[Optional[StrictStr], Field(description="A page token, received from a previous call (Pagination is not supported currently).")] = None, **kwargs) -> ApiResponse:  # noqa: E501
        """Search Account Info  # noqa: E501

        Searches Account Info based on the input query.  # noqa: E501
        This method makes a synchronous HTTP request by default. To make an
        asynchronous HTTP request, please pass async_req=True

        >>> thread = api.account_info_api_search_account_infos_with_http_info(vnd_com_blackrock_request_id, vnd_com_blackrock_origin_timestamp, search, acct_info_search_type, page_size, page_token, async_req=True)
        >>> result = thread.get()

        :param vnd_com_blackrock_request_id: A unique identifier for this request. (required)
        :type vnd_com_blackrock_request_id: str
        :param vnd_com_blackrock_origin_timestamp: Timestamp assigned to this request at origin, in \"HTTP-date\" format as defined by RFC 7231. (required)
        :type vnd_com_blackrock_origin_timestamp: datetime
        :param search: Search string. Represents Search string (atleast two characters). (required)
        :type search: str
        :param acct_info_search_type: Account Info Search Type. Represents search type.   - ACCOUNT_INFO_SEARCH_TYPE_UNSPECIFIED: The API will default to the ACCOUNT_NAME type  - ACCOUNT_INFO_SEARCH_TYPE_ACCOUNT_NAME: This is the default value Fields searched - accountName.
        :type acct_info_search_type: str
        :param page_size: The maximum value is 100; values above 100 will be coerced to 100 If unspecified, the default value to return is 100 The maximum number of Brokers to return (Pagination is not supported currently).
        :type page_size: int
        :param page_token: A page token, received from a previous call (Pagination is not supported currently).
        :type page_token: str
        :param async_req: Whether to execute the request asynchronously.
        :type async_req: bool, optional
        :param _preload_content: if False, the ApiResponse.data will
                                 be set to none and raw_data will store the 
                                 HTTP response body without reading/decoding.
                                 Default is True.
        :type _preload_content: bool, optional
        :param _return_http_data_only: response data instead of ApiResponse
                                       object with status code, headers, etc
        :type _return_http_data_only: bool, optional
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the authentication
                              in the spec for a single request.
        :type _request_auth: dict, optional
        :type _content_type: string, optional: force content-type for the request
        :return: Returns the result object.
                 If the method is called asynchronously,
                 returns the request thread.
        :rtype: tuple(V1SearchAccountInfosResponse, status_code(int), headers(HTTPHeaderDict))
        """

        _params = locals()

        _all_params = [
            'vnd_com_blackrock_request_id',
            'vnd_com_blackrock_origin_timestamp',
            'search',
            'acct_info_search_type',
            'page_size',
            'page_token'
        ]
        _all_params.extend(
            [
                'async_req',
                '_return_http_data_only',
                '_preload_content',
                '_request_timeout',
                '_request_auth',
                '_content_type',
                '_headers'
            ]
        )

        # validate the arguments
        for _key, _val in _params['kwargs'].items():
            if _key not in _all_params:
                raise ApiTypeError(
                    "Got an unexpected keyword argument '%s'"
                    " to method account_info_api_search_account_infos" % _key
                )
            _params[_key] = _val
        del _params['kwargs']

        _collection_formats = {}

        # process the path parameters
        _path_params = {}

        # process the query parameters
        _query_params = []
        if _params.get('search') is not None:  # noqa: E501
            _query_params.append(('search', _params['search']))

        if _params.get('acct_info_search_type') is not None:  # noqa: E501
            _query_params.append(('acctInfoSearchType', _params['acct_info_search_type'].value))

        if _params.get('page_size') is not None:  # noqa: E501
            _query_params.append(('pageSize', _params['page_size']))

        if _params.get('page_token') is not None:  # noqa: E501
            _query_params.append(('pageToken', _params['page_token']))

        # process the header parameters
        _header_params = dict(_params.get('_headers', {}))
        if _params['vnd_com_blackrock_request_id']:
            _header_params['VND.com.blackrock.Request-ID'] = _params['vnd_com_blackrock_request_id']

        if _params['vnd_com_blackrock_origin_timestamp']:
            _header_params['VND.com.blackrock.Origin-Timestamp'] = _params['vnd_com_blackrock_origin_timestamp']

        # process the form parameters
        _form_params = []
        _files = {}
        # process the body parameter
        _body_params = None
        # set the HTTP header `Accept`
        _header_params['Accept'] = self.api_client.select_header_accept(
            ['application/json'])  # noqa: E501

        # authentication setting
        _auth_settings = ['APIKeyHeader', 'OAuth2ClientCredentials', 'basicAuth', 'OAuth2AccessCode', 'ClientKeyHeader']  # noqa: E501

        _response_types_map = {
            '200': "V1SearchAccountInfosResponse",
            '400': "AccountInfoAPIFilterAccountInfos400Response",
            '401': "AccountInfoAPIFilterAccountInfos400Response",
            '403': "AccountInfoAPIFilterAccountInfos400Response",
            '404': "AccountInfoAPIFilterAccountInfos400Response",
        }

        return self.api_client.call_api(
            '/accountInfos:search', 'GET',
            _path_params,
            _query_params,
            _header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            response_types_map=_response_types_map,
            auth_settings=_auth_settings,
            async_req=_params.get('async_req'),
            _return_http_data_only=_params.get('_return_http_data_only'),  # noqa: E501
            _preload_content=_params.get('_preload_content', True),
            _request_timeout=_params.get('_request_timeout'),
            collection_formats=_collection_formats,
            _request_auth=_params.get('_request_auth'))
