# coding: utf-8

"""
    Broker

    API contains operations on Broker resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr, conlist

class V1BrokerQuery(BaseModel):
    """
    The query required to perform a filter query.
    """
    broker_tickers: Optional[conlist(StrictStr)] = Field(None, alias="brokerTickers", description="Broker ticker for which broker desk data is to be retrieved.")
    broker_type: Optional[StrictStr] = Field(None, alias="brokerType", description="Broker Type.")
    defunct: Optional[StrictBool] = Field(None, description="Defunct flag - to load only defunct counterparties.")
    __properties = ["brokerTickers", "brokerType", "defunct"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BrokerQuery:
        """Create an instance of V1BrokerQuery from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BrokerQuery:
        """Create an instance of V1BrokerQuery from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BrokerQuery.parse_obj(obj)

        _obj = V1BrokerQuery.parse_obj({
            "broker_tickers": obj.get("brokerTickers"),
            "broker_type": obj.get("brokerType"),
            "defunct": obj.get("defunct")
        })
        return _obj

