# coding: utf-8

"""
    Broker Confirm Routing

    API contains operations on Broker Confirm Routing resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.broker.v1.BrokerConfirmRoutingAPI.models.v1_broker_confirm_routing_query import V1BrokerConfirmRoutingQuery

class V1FilterBrokerConfirmRoutingsRequest(BaseModel):
    """
    The request message for BrokerConfirmRoutingAPI.FilterBrokerConfirmRoutings.
    """
    broker_confirm_routing_query: Optional[V1BrokerConfirmRoutingQuery] = Field(None, alias="brokerConfirmRoutingQuery")
    page_size: Optional[StrictInt] = Field(None, alias="pageSize", description="The maximum number of BrokerConfirmRoutings to return. The service may return fewer than this value. If unspecified i.e 0, then complete list of BrokerConfirmRoutings will be returned.")
    page_token: Optional[StrictStr] = Field(None, alias="pageToken", description="A page token, received from a previous 'FilterBrokerConfirmRoutings' call. Provide this to retrieve the subsequent page.  When paginating, all other parameters provided to 'FilterBrokerConfirmRoutings' must match the call that provided the page token.")
    __properties = ["brokerConfirmRoutingQuery", "pageSize", "pageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterBrokerConfirmRoutingsRequest:
        """Create an instance of V1FilterBrokerConfirmRoutingsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of broker_confirm_routing_query
        if self.broker_confirm_routing_query:
            _dict['brokerConfirmRoutingQuery'] = self.broker_confirm_routing_query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterBrokerConfirmRoutingsRequest:
        """Create an instance of V1FilterBrokerConfirmRoutingsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterBrokerConfirmRoutingsRequest.parse_obj(obj)

        _obj = V1FilterBrokerConfirmRoutingsRequest.parse_obj({
            "broker_confirm_routing_query": V1BrokerConfirmRoutingQuery.from_dict(obj.get("brokerConfirmRoutingQuery")) if obj.get("brokerConfirmRoutingQuery") is not None else None,
            "page_size": obj.get("pageSize"),
            "page_token": obj.get("pageToken")
        })
        return _obj

