# coding: utf-8

"""
    Broker Confirm Routing

    API contains operations on Broker Confirm Routing resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List, Optional
from pydantic import BaseModel, Field, StrictStr, conlist
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.broker.v1.BrokerConfirmRoutingAPI.models.v1_broker_confirm_routing import V1BrokerConfirmRouting

class V1FilterBrokerConfirmRoutingsResponse(BaseModel):
    """
    The response message for BrokerConfirmRoutingAPI.FilterBrokerConfirmRoutings.
    """
    broker_confirm_routings: Optional[conlist(V1BrokerConfirmRouting)] = Field(None, alias="brokerConfirmRoutings", description="Broker confirm routings to be returned.")
    next_page_token: Optional[StrictStr] = Field(None, alias="nextPageToken", description="A token, which can be sent as 'page_token' to retrieve the next page. Currently the API does not support pagination.")
    __properties = ["brokerConfirmRoutings", "nextPageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterBrokerConfirmRoutingsResponse:
        """Create an instance of V1FilterBrokerConfirmRoutingsResponse from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in broker_confirm_routings (list)
        _items = []
        if self.broker_confirm_routings:
            for _item in self.broker_confirm_routings:
                if _item:
                    _items.append(_item.to_dict())
            _dict['brokerConfirmRoutings'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterBrokerConfirmRoutingsResponse:
        """Create an instance of V1FilterBrokerConfirmRoutingsResponse from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterBrokerConfirmRoutingsResponse.parse_obj(obj)

        _obj = V1FilterBrokerConfirmRoutingsResponse.parse_obj({
            "broker_confirm_routings": [V1BrokerConfirmRouting.from_dict(_item) for _item in obj.get("brokerConfirmRoutings")] if obj.get("brokerConfirmRoutings") is not None else None,
            "next_page_token": obj.get("nextPageToken")
        })
        return _obj

