# coding: utf-8

"""
    Broker External Alias

    API contains operations on Broker External Alias resource.  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictBool, StrictStr
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.broker.v1.BrokerExternalAliasAPI.models.enums_filter_type import EnumsFilterType
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.broker.v1.BrokerExternalAliasAPI.models.v1_broker_external_alias_extended_query import V1BrokerExternalAliasExtendedQuery

class V1BrokerExternalAliasQuery(BaseModel):
    """
    V1BrokerExternalAliasQuery
    """
    id: Optional[StrictStr] = Field(None, description="Aladdin Broker Identifier (Numeric) (Not supported currently).")
    broker_ticker: Optional[StrictStr] = Field(None, alias="brokerTicker", description="Broker ticker.")
    load_defunct: Optional[StrictBool] = Field(None, alias="loadDefunct", description="Load Defunct Flag - If true , will load all (including defuncts) , else will only load non defunct data.")
    broker_external_alias_extended_query: Optional[V1BrokerExternalAliasExtendedQuery] = Field(None, alias="brokerExternalAliasExtendedQuery")
    filter_type: Optional[EnumsFilterType] = Field(None, alias="filterType")
    __properties = ["id", "brokerTicker", "loadDefunct", "brokerExternalAliasExtendedQuery", "filterType"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BrokerExternalAliasQuery:
        """Create an instance of V1BrokerExternalAliasQuery from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of broker_external_alias_extended_query
        if self.broker_external_alias_extended_query:
            _dict['brokerExternalAliasExtendedQuery'] = self.broker_external_alias_extended_query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BrokerExternalAliasQuery:
        """Create an instance of V1BrokerExternalAliasQuery from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BrokerExternalAliasQuery.parse_obj(obj)

        _obj = V1BrokerExternalAliasQuery.parse_obj({
            "id": obj.get("id"),
            "broker_ticker": obj.get("brokerTicker"),
            "load_defunct": obj.get("loadDefunct"),
            "broker_external_alias_extended_query": V1BrokerExternalAliasExtendedQuery.from_dict(obj.get("brokerExternalAliasExtendedQuery")) if obj.get("brokerExternalAliasExtendedQuery") is not None else None,
            "filter_type": obj.get("filterType")
        })
        return _obj

