# coding: utf-8

"""
    Aladdin Broker Contact

    Contact defines the Recipient details to which we want to communicate with external parties like Custodians/Brokers  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import List
from pydantic import BaseModel, Field, conlist
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.contact.v1.ContactAPI.models.v1_create_contact_request import V1CreateContactRequest

class V1BatchCreateContactsRequest(BaseModel):
    """
    The request message for ContactAPI.BatchCreateContacts.
    """
    requests: conlist(V1CreateContactRequest) = Field(..., description="A maximum of 100 contacts can be created in a batch. First Name, Last Name and external account id are mandatory in all create requests. Broker Code , Broker External Organization ID should not be provided in any create request Broker Portfolio Id should only be provided when Broker Type is PORTFOLIO.")
    __properties = ["requests"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1BatchCreateContactsRequest:
        """Create an instance of V1BatchCreateContactsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of each item in requests (list)
        _items = []
        if self.requests:
            for _item in self.requests:
                if _item:
                    _items.append(_item.to_dict())
            _dict['requests'] = _items
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1BatchCreateContactsRequest:
        """Create an instance of V1BatchCreateContactsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1BatchCreateContactsRequest.parse_obj(obj)

        _obj = V1BatchCreateContactsRequest.parse_obj({
            "requests": [V1CreateContactRequest.from_dict(_item) for _item in obj.get("requests")] if obj.get("requests") is not None else None
        })
        return _obj

