# coding: utf-8

"""
    Aladdin Broker Contact

    Contact defines the Recipient details to which we want to communicate with external parties like Custodians/Brokers  # noqa: E501

    The version of the OpenAPI document: 1.0.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""


from __future__ import annotations
import pprint
import re  # noqa: F401
import json


from typing import Optional
from pydantic import BaseModel, Field, StrictInt, StrictStr
from asdk_plugin_investment_operations.agraph.investment_operations.reference_data.contact.v1.ContactAPI.models.v1_contacts_query import V1ContactsQuery

class V1FilterContactsRequest(BaseModel):
    """
    The request message for ContactAPI.FilterContacts.
    """
    contacts_query: Optional[V1ContactsQuery] = Field(None, alias="contactsQuery")
    page_size: Optional[StrictInt] = Field(None, alias="pageSize", description="The maximum number of Contacts to return. The service may return fewer than this value. If unspecified, at most 10 Contacts will be returned. The maximum value is 10; values above 10 will be coerced to 10.")
    page_token: Optional[StrictStr] = Field(None, alias="pageToken", description="A page token, received from a previous 'ListContacts' call. Provide this to retrieve the subsequent page.  When paginating, all other parameters provided to 'ListContacts' must match the call that provided the page token.")
    __properties = ["contactsQuery", "pageSize", "pageToken"]

    class Config:
        """Pydantic configuration"""
        allow_population_by_field_name = True
        validate_assignment = True

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.dict(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> V1FilterContactsRequest:
        """Create an instance of V1FilterContactsRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self):
        """Returns the dictionary representation of the model using alias"""
        _dict = self.dict(by_alias=True,
                          exclude={
                          },
                          exclude_none=True)
        # override the default output from pydantic by calling `to_dict()` of contacts_query
        if self.contacts_query:
            _dict['contactsQuery'] = self.contacts_query.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: dict) -> V1FilterContactsRequest:
        """Create an instance of V1FilterContactsRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return V1FilterContactsRequest.parse_obj(obj)

        _obj = V1FilterContactsRequest.parse_obj({
            "contacts_query": V1ContactsQuery.from_dict(obj.get("contactsQuery")) if obj.get("contactsQuery") is not None else None,
            "page_size": obj.get("pageSize"),
            "page_token": obj.get("pageToken")
        })
        return _obj

